"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = ChidoLink;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _reactUniversalComponent = _interopRequireDefault(require("react-universal-component"));

var _router = require("@reach/router");

var _reachUtils = require("../../app-dir/reach-utils");

var _utils = require("../../app-dir/utils");

var getChunkName = function getChunkName(to) {
  var simpleTo = to[0] === '/' && to !== '/' ? to.substr(1) : to;
  simpleTo = to === '/' ? to : "".concat(simpleTo, "/");
  var chunkName = window.__fullRoutes[simpleTo];
  chunkName = chunkName || window.__fullRoutes[to];
  return chunkName;
};

var tryPrefetch = function tryPrefetch(to) {
  if (_utils.isDev) {
    return null;
  }

  var chunkName = getChunkName(to);
  var importFn = window.__asyncChunks[chunkName];

  if (!importFn) {
    var routesArr = window.__dynamicRoutes.map(function (obj) {
      return {
        path: obj.route,
        chunkName: obj.chunkName
      };
    });

    var dynamicRoute = (0, _reachUtils.pick)(routesArr, to);

    if (dynamicRoute) {
      importFn = window.__asyncChunks[dynamicRoute.route.chunkName];
    }
  }

  return importFn;
};

function ChidoLink(fullprops) {
  var to = fullprops.to,
      _onClick = fullprops.onClick,
      _onMouseEnter = fullprops.onMouseEnter,
      _onFocus = fullprops.onFocus,
      props = (0, _objectWithoutProperties2.default)(fullprops, ["to", "onClick", "onMouseEnter", "onFocus"]);
  return _react.default.createElement(_router.Link, (0, _extends2.default)({
    to: to,
    onFocus: function onFocus(e) {
      _onFocus && _onFocus(e);
      var importFn = tryPrefetch(to);

      if (importFn) {
        (0, _reactUniversalComponent.default)(importFn).preload();
      }
    },
    onMouseEnter: function onMouseEnter(e) {
      _onMouseEnter && _onMouseEnter(e);
      var importFn = tryPrefetch(to);

      if (importFn) {
        (0, _reactUniversalComponent.default)(importFn).preload();
      }
    },
    onClick: function onClick(event) {
      _onClick && _onClick(event);

      if (event.button === 0 && // ignore right clicks
      !props.target && // let browser handle "target=_blank"
      !event.defaultPrevented && // onClick prevented default
      !event.metaKey && // ignore clicks with modifier keys...
      !event.altKey && !event.ctrlKey && !event.shiftKey) {
        event.preventDefault();
        var importFn = tryPrefetch(to);

        if (importFn) {
          // What happen if the promise gets rejected?
          (0, _reactUniversalComponent.default)(importFn).preload().then(function () {
            return (0, _router.navigate)(to);
          });
        } else {
          (0, _router.navigate)(to);
        }
      }
    }
  }, props));
}