"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var webpack = require('webpack');

var ensureDirs = require('./ensureDirs');

var report = require('../report');

var routesWebpack = require('../routes-generator/routes.webpack');

var clientWebpack = require('../client-webpack/client.webpack');

var staticHtmlWebpack = require('../html-generator/html.webpack');

var wireHtaccess = require('../custom-router/wire-htaccess');

var promiseWebpack = function promiseWebpack(config) {
  return new Promise(function (resolve, reject) {
    webpack(config, function (err) {
      var stats = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {
        compilation: {}
      };
      var routesErr = stats.compilation.errors;

      if (err || routesErr.length > 0) {
        return reject(err || routesErr);
      }

      resolve(stats);
    });
  });
};

module.exports =
/*#__PURE__*/
function () {
  var _build = (0, _asyncToGenerator2.default)(
  /*#__PURE__*/
  _regenerator.default.mark(function _callee(argv) {
    var copiedSuccess, routesStats, router;
    return _regenerator.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.next = 2;
            return ensureDirs();

          case 2:
            copiedSuccess = _context.sent;

            if (!copiedSuccess) {
              report.failure('shite');
            }

            _context.prev = 4;
            report.info('making routes file with webpack');
            _context.next = 8;
            return promiseWebpack(routesWebpack('routing', {
              mode: 'production'
            }));

          case 8:
            routesStats = _context.sent;
            report.success();
            report.info('build routes from emitted file');

            require("".concat(process.cwd(), "/.app/routes/buildRoutes"));

            report.success();
            report.info('build client app');
            _context.next = 16;
            return promiseWebpack(clientWebpack('client', {
              mode: 'production'
            }));

          case 16:
            report.success();
            report.info('build static html');
            _context.next = 20;
            return promiseWebpack(staticHtmlWebpack('static', {
              mode: 'production'
            }));

          case 20:
            report.success();
            report.info('using htaccess');
            _context.next = 24;
            return wireHtaccess();

          case 24:
            router = _context.sent;
            console.log({
              router: router
            });
            report.success();
            report.chido('your app is production ready!!!');
            _context.next = 33;
            break;

          case 30:
            _context.prev = 30;
            _context.t0 = _context["catch"](4);
            report.failure(_context.t0);

          case 33:
          case "end":
            return _context.stop();
        }
      }
    }, _callee, this, [[4, 30]]);
  }));

  function build(_x) {
    return _build.apply(this, arguments);
  }

  return build;
}();