"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var fse = require('fs-extra');

var rimraf = require('rimraf');

var slash = require('slash');

var buildChunks = require('../routes-generator/build-chunks');

var report = require('../report');

module.exports =
/*#__PURE__*/
function () {
  var _ensureDirs = (0, _asyncToGenerator2.default)(
  /*#__PURE__*/
  _regenerator.default.mark(function _callee() {
    var processDir, appDir, appDirExists, dotAppDir, dotAppDirExists, copiedSuccess, publicDir, publicDirExists;
    return _regenerator.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            processDir = process.cwd();
            appDir = slash("".concat(__dirname, "/../../app-dir/"));
            report.info('searching for app-dir');
            _context.next = 5;
            return fse.pathExists(appDir);

          case 5:
            appDirExists = _context.sent;

            if (appDirExists) {
              _context.next = 8;
              break;
            }

            throw new Error('There\'s a problem with your "chido" installation, please "npm uninstall chido" and then run "npm install chido" again!!!');

          case 8:
            report.success('app-dir exists');
            report.info('copying app-dir to .app');
            dotAppDir = slash("".concat(processDir, "/.app"));
            _context.next = 13;
            return fse.pathExists(dotAppDir);

          case 13:
            dotAppDirExists = _context.sent;

            if (dotAppDirExists) {
              rimraf.sync(dotAppDir);
            }

            _context.next = 17;
            return fse.copy(appDir, dotAppDir);

          case 17:
            _context.next = 19;
            return fse.pathExists(dotAppDir);

          case 19:
            copiedSuccess = _context.sent;

            if (copiedSuccess) {
              report.success('.app dir copied');
            }

            report.info('building chunks');
            buildChunks();
            report.success('chunks built!!!');
            report.info('searching for public directory');
            publicDir = slash("".concat(processDir, "/public"));
            _context.next = 28;
            return fse.pathExists(publicDir);

          case 28:
            publicDirExists = _context.sent;

            if (publicDirExists) {
              report.info('removing public directory');
              rimraf.sync(publicDir);
            }

            _context.next = 32;
            return fse.ensureDir(publicDir);

          case 32:
            report.success('brand new public directory');
            return _context.abrupt("return", true);

          case 34:
          case "end":
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  function ensureDirs() {
    return _ensureDirs.apply(this, arguments);
  }

  return ensureDirs;
}();