"use strict";

var path = require('path');

var WriteFilePlugin = require('write-file-webpack-plugin');

var HtmlWebpackPlugin = require('html-webpack-plugin');

var webpack = require('webpack');

var rimraf = require('rimraf');

var nunjucks = require('nunjucks');

var fs = require('fs');

var devTemplatePath = path.join(__dirname, 'dev-template.html');
var templatePath = path.join(__dirname, '../default-html/index.html');
rimraf.sync(devTemplatePath);
var templateString = fs.readFileSync(templatePath).toString();
var template = nunjucks.renderString(templateString);
fs.writeFileSync(devTemplatePath, template);
module.exports = {
  entry: {
    bundle: ['webpack-hot-middleware/client?__webpack_hmr&reload=true&overlay=true', path.join(process.cwd(), '/.app/dev-renderer.js')]
  },
  mode: 'development',
  output: {
    path: path.join(process.cwd(), '/public/'),
    publicPath: '/',
    filename: '[name].js'
  },
  plugins: [new HtmlWebpackPlugin({
    template: path.resolve(devTemplatePath)
  }), new WriteFilePlugin(), new webpack.HotModuleReplacementPlugin()]
};