"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

/* eslint-disable-next-line import/no-unresolved */
var fs = require('fs');
/*
  Fulfill these use cases:
  1. /hello/:language/:person (two dynamic params next to each other)
    How to route `/hello/spa` and `/hello/spa/tonatiuh` to its correspondant directory
*/


module.exports = function wireHtaccess() {
  var currentDir = process.cwd();
  var rawDynamic = fs.readFileSync("".concat(currentDir, "/.app/routes/chido-routes.json"));
  rawDynamic = JSON.parse(rawDynamic.toString());
  var dynamicArr = Object.values(rawDynamic).filter(function (_ref) {
    var route = _ref.route;
    return !!route;
  });
  var regexString = /[^/]{2,256}$/;
  var lastRegexString = /[^/]{2,256}\/?$/;
  var doubleDotRegex = /:[-a-zA-Z0-9@:%_+.~#?&=]*/;
  var validRoutes = [];
  dynamicArr.forEach(function (_ref2) {
    var route = _ref2.route,
        directory = _ref2.directory;
    var segments = route.split('/');
    segments = segments.map(function (segment, index) {
      if (index === segments.length - 1) {
        return segment.replace(doubleDotRegex, lastRegexString.toString());
      }

      return segment.replace(doubleDotRegex, regexString.toString());
    });
    segments = segments.join('/');
    validRoutes = [].concat((0, _toConsumableArray2.default)(validRoutes), ["RewriteCond %{REQUEST_URI} !=^".concat(segments, "\n      RewriteRule ").concat(segments, " /public/").concat(directory, " [L]")]);
  });
  return validRoutes;
};