"use strict";

var chalk = require('chalk');

var _console = console,
    log = _console.log;

var alerter = function alerter(color, type) {
  var msg = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : '';
  return log("".concat(chalk[color](type), " ").concat(msg));
};

module.exports = {
  success: function success() {
    var msg = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 'done';
    return alerter('green', 'success', msg);
  },
  error: function error(msg) {
    return alerter('red', 'error', msg);
  },
  event: function event(msg) {
    return alerter('blue', 'info', msg);
  },
  info: function info(msg) {
    return alerter('blue', 'info', msg);
  },
  failure: function failure(msg) {
    alerter('red', 'FAILURE', msg);
    process.exit(1);
  },
  warn: function warn(msg) {
    return alerter('yellow', 'warning', msg);
  },
  chido: function chido(msg) {
    return alerter('cyan', "[chido] ".concat(msg));
  }
};