"use strict";

// RUN all the React components in the pages folder and build a Router
var fse = require('fs-extra');

var fs = require('fs');

var path = require('path');

var slash = require('slash');

var kebabCase = require('lodash/kebabCase');

var report = require('../report/index');

var jsMatch = require('../../app-dir/utils/jsMatch');

var currentDir = process.cwd();
var routesDir = path.join(currentDir, '/.app/routes');

if (!fs.existsSync(routesDir)) {
  fse.ensureDirSync(routesDir);
}

var buildchido = function buildchido() {
  var pagePath = path.join(currentDir, '/src/pages');

  if (!fse.existsSync(pagePath)) {
    return report.failure('make sure you have a working /src/pages');
  }

  var importChunks = '';
  var requireChunks = '';
  var fileRouter = '';
  var files = [];
  var filesArr = fs.readdirSync(pagePath);
  var default404 = slash(path.join(currentDir, '/.app/404/default-404.js'));
  var has404 = !!filesArr.find(function (P) {
    return P === '404.js';
  });
  filesArr.forEach(function (P) {
    if (jsMatch(P)) {
      var fullPath = slash(path.join(pagePath, P));
      files.push(fullPath);
      var chunkName = "site--pages-".concat(kebabCase(P));
      importChunks = "".concat(importChunks, "\n      \"").concat(chunkName, "\": import(\"").concat(fullPath, "\"/* webpackChunkName: \"").concat(chunkName, "\" */),");
      requireChunks = "".concat(requireChunks, "\n      \"").concat(chunkName, "\": require(\"").concat(slash(pagePath), "/").concat(P, "\"),");
      fileRouter = "".concat(fileRouter, "\n      \"").concat(chunkName, "\": \"").concat(P.split('.js')[0], "/\",");
    }
  });

  if (!has404) {
    var chunkName404 = "site--pages-".concat(kebabCase('404.js'));
    importChunks = "".concat(importChunks, "\n      \"").concat(chunkName404, "\": import(\"").concat(default404, "\"/* webpackChunkName: \"").concat(chunkName404, "\" */),");
    requireChunks = "".concat(requireChunks, "\n      \"").concat(chunkName404, "\": require(\"").concat(slash(default404), "\"),");
    fileRouter = "".concat(fileRouter, "\n      \"").concat(chunkName404, "\": \"404/\",");
  }

  importChunks = "module.exports = {".concat(importChunks, "\n}\n  ");
  requireChunks = "module.exports = {".concat(requireChunks, "\n}\n  ");
  fileRouter = "module.exports = {".concat(fileRouter, "\n}");
  fs.writeFileSync("".concat(currentDir, "/.app/routes/async-chunks.js"), importChunks);
  fs.writeFileSync("".concat(currentDir, "/.app/routes/sync-chunks.js"), requireChunks);
  fs.writeFileSync("".concat(currentDir, "/.app/routes/file-router.js"), fileRouter);
  return files;
};

module.exports = buildchido;

if (require.main === module) {
  buildchido();
}